#include "adminwindow.h"
#include "ui_adminwindow.h"

AdminWindow::AdminWindow(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::adminwindow)
{

    this->newTestWidget = new addNewTestWidget(this);
    newTestWidget->hide();
    this->deleteWidget = new deletetestwidget(this);
    deleteWidget->hide();

    ui->pushButton = new QPushButton("Назад");

    ui->setupUi(this);
    ui->pushButton->hide();
    QPalette qpalette;
    qpalette.setColor(this->backgroundRole(), QColor("#ccffff"));
    this->setAutoFillBackground(true);
    this->setPalette(qpalette);

    this->setWindowTitle("Окно администратора");

    db = QSqlDatabase::addDatabase("QPSQL");
    db.setHostName("localhost");
    db.setDatabaseName("android_tester");
    db.setPort(5432);
    db.setUserName("postgres");
    db.setPassword("3868652");
    db.open();

    results = new QTableView(this);
    results->hide();
    redactWidget = new RedactionWidget(this);

    connect(ui->addNewTestBtn, SIGNAL(clicked()), this, SLOT(addNewTest()));
    connect(ui->addNewTestBtn, SIGNAL(clicked()), this, SLOT(hideStartWindow()));

    connect(this->newTestWidget, SIGNAL(onClosed()), this, SLOT(showStartWindow()));

    connect(newTestWidget->returnButton, SIGNAL(clicked()), this->newTestWidget, SLOT(hide()));
    connect(newTestWidget->returnButton, SIGNAL(clicked()), this, SLOT(showStartWindow()));

    connect(deleteWidget->returnButton, SIGNAL(clicked()), this->deleteWidget, SLOT(hide()));
    connect(deleteWidget->returnButton, SIGNAL(clicked()), this, SLOT(showStartWindow()));

    connect(ui->checkProgressBtn, SIGNAL(clicked()), this, SLOT(checkStats()));
    connect(ui->checkProgressBtn, SIGNAL(clicked()), this, SLOT(hideStartWindow()));

    connect(ui->pushButton, SIGNAL(clicked()), this, SLOT(showStartWindow()));
    connect(ui->pushButton, SIGNAL(clicked()), this->results, SLOT(hide()));

    connect(ui->deleteTestBtn, SIGNAL(clicked()), this, SLOT(deleteTest()));
    connect(ui->deleteTestBtn, SIGNAL(clicked()), this, SLOT(hideStartWindow()));

    connect(ui->deleteTestBtn, SIGNAL(clicked()), this, SLOT(sendDataBase()));
    connect(this, SIGNAL(sDataBase(const QSqlDatabase&)), deleteWidget, SLOT(receiveDataBase(const QSqlDatabase &)));

    connect(ui->redactTestBtn, SIGNAL(clicked()), this, SLOT(sendDataBase));
    connect(this, SIGNAL(sDataBase(const QSqlDataBase&)),redactWidget, SLOT(receiveDataBase(const QSqlDatabase&)));
    connect(ui->redactTestBtn, SIGNAL(clicked()), this, SLOT(hideStartWindow()));
    connect(ui->redactTestBtn, SIGNAL(clicked()), redactWidget, SLOT(show()));

    connect(redactWidget->exit, SIGNAL(clicked()), this, SLOT(showStartWindow()));
    connect(redactWidget->exit, SIGNAL(clicked()), redactWidget, SLOT(hide()));

    connect(ui->logout_btn, SIGNAL(clicked()), this, SIGNAL(onClosed()));
}

AdminWindow::~AdminWindow()
{
    delete ui;
}

void AdminWindow::sendDataBase()
{
    emit sDataBase(db);
}

void AdminWindow::addNewTest()
{
    newTestWidget->show();
    newTestWidget->addNewTest();
}

void AdminWindow::hideStartWindow()
{
    ui->addNewTestBtn->hide();
    ui->checkProgressBtn->hide();
    ui->deleteTestBtn->hide();
    ui->label->hide();
    ui->lblMenu->hide();
    ui->logout_btn->hide();
    ui->redactTestBtn->hide();
}

void AdminWindow::showStartWindow()
{
    ui->addNewTestBtn->show();
    ui->checkProgressBtn->show();
    ui->deleteTestBtn->show();
    ui->label->show();
    ui->lblMenu->show();
    ui->logout_btn->show();
    results->hide();
    ui->pushButton->hide();
    ui->redactTestBtn->show();
}

void AdminWindow::checkStats()
{

    QSqlQueryModel *model = new QSqlQueryModel(results);
    model->setQuery(QSqlQuery("SELECT * FROM test_results;", db));
    results->setModel(model);
    results->resize(600,400);
    results->show();
    ui->pushButton->show();

}

void AdminWindow::hideAddWidget()
{
    newTestWidget->hide();
}

void AdminWindow::deleteTest()
{
    deleteWidget->show();
}
