#ifndef ADMINWINDOW_H
#define ADMINWINDOW_H

#include "testentity.h"
#include "addnewtestwidget.h"
#include "deletetestwidget.h"
#include "redactionwidget.h"

#include <QWidget>
#include <QPalette>
#include <QSqlDatabase>
#include <QSqlQuery>
#include <QSqlQueryModel>
#include <QTableView>
#include <QStandardItemModel>
#include <QDebug>

namespace Ui {
class adminwindow;
}

class AdminWindow : public QWidget
{
    Q_OBJECT

public:
    explicit AdminWindow(QWidget *parent = nullptr);
    ~AdminWindow();

signals:
    void sDataBase(const QSqlDatabase& db);
    void onClosed();

public slots:
    void sendDataBase();
    void addNewTest();
    void hideStartWindow();
    void showStartWindow();
    void checkStats();
    void hideAddWidget();
    void deleteTest();


private:
    TestEntity *testToAdd;
    Ui::adminwindow *ui;
    QSqlDatabase db;
    QTableView *results;
    addNewTestWidget *newTestWidget;
    deletetestwidget *deleteWidget;
    RedactionWidget *redactWidget;

};

#endif // ADMINWINDOW_H
